import 'package:flutter/material.dart';
import 'package:ibad/ibad.dart';
import 'package:flutter/services.dart';

void main() => runApp(MyApp());

late Map<String, dynamic> data;
late String callbackdata = "";
final keycontroller = TextEditingController();
final amountcontroller = TextEditingController();
final referencenumbercontroller = TextEditingController();
final customeremailcontroller = TextEditingController();
final customernumbercontroller = TextEditingController();
final consumernamecontroller = TextEditingController();

class MyApp extends StatelessWidget {
  @override
  Widget build(BuildContext context) {

    SystemChrome.setPreferredOrientations([
      DeviceOrientation.portraitUp,
    ]);

    return MaterialApp(
      title: 'Welcome to Flutter',
      home: Scaffold(body: LoginPage(title: "LoginPage")),
    );
  }
}

class LoginPage extends StatefulWidget {
  LoginPage({required this.title});
  final String title;

  @override
  _LoginPageState createState() => _LoginPageState();
}

class _LoginPageState extends State<LoginPage> {
  @override
  void initState() {
    super.initState();

    keycontroller.text = "3ffd958d-0fc8-4a36-b577-cf81c356f672";
    referencenumbercontroller.text = "65";
    amountcontroller.text = "100";
    customeremailcontroller.text = "ibad@gmail.com";
    customernumbercontroller.text = "03132689474";
    consumernamecontroller.text = "Ibad Ahmed";
  }

  @override
  Widget build(BuildContext context) {
    final node = FocusScope.of(context);

    return ListView(
      children: [
        Column(
          mainAxisAlignment: MainAxisAlignment.center,
          children: [
            Container(
              child: Column(
                children: [
                  Container(
                    margin: EdgeInsets.only(
                        left: 5.0, top: 25.0, right: 5.0, bottom: 5.0),
                    child: TextField(
                      textInputAction: TextInputAction.next,
                      onEditingComplete: () => node.nextFocus(),
                      controller: keycontroller,
                      decoration: InputDecoration(
                        border: OutlineInputBorder(),
                        labelText: "Key",
                      ),
                    ),
                  ),
                  Container(
                    margin:
                    EdgeInsets.symmetric(vertical: 5.0, horizontal: 5.0),
                    child: TextField(
                      controller: amountcontroller,
                      textInputAction: TextInputAction.done,
                      onEditingComplete: () => node.nextFocus(),
                      enableSuggestions: false,
                      autocorrect: false,
                      decoration: InputDecoration(
                        border: OutlineInputBorder(),
                        fillColor: Colors.white,
                        labelText: "Amount",
                      ),
                    ),
                  ),
                  Container(
                    margin:
                    EdgeInsets.symmetric(vertical: 5.0, horizontal: 5.0),
                    child: TextField(
                      controller: referencenumbercontroller,
                      textInputAction: TextInputAction.done,
                      onEditingComplete: () => node.nextFocus(),
                      enableSuggestions: false,
                      autocorrect: false,
                      decoration: InputDecoration(
                        border: OutlineInputBorder(),
                        fillColor: Colors.white,
                        labelText: "Reference Number",
                      ),
                    ),
                  ),
                  Container(
                    margin:
                    EdgeInsets.symmetric(vertical: 5.0, horizontal: 5.0),
                    child: TextField(
                      controller: customeremailcontroller,
                      textInputAction: TextInputAction.done,
                      onEditingComplete: () => node.nextFocus(),
                      enableSuggestions: false,
                      autocorrect: false,
                      decoration: InputDecoration(
                        border: OutlineInputBorder(),
                        fillColor: Colors.white,
                        labelText: "Email",
                      ),
                    ),
                  ),
                  Container(
                    margin:
                    EdgeInsets.symmetric(vertical: 5.0, horizontal: 5.0),
                    child: TextField(
                      controller: customernumbercontroller,
                      textInputAction: TextInputAction.done,
                      onEditingComplete: () => node.nextFocus(),
                      enableSuggestions: false,
                      autocorrect: false,
                      decoration: InputDecoration(
                        border: OutlineInputBorder(),
                        fillColor: Colors.white,
                        labelText: "Phone",
                      ),
                    ),
                  ),
                  Container(
                    margin:
                    EdgeInsets.symmetric(vertical: 5.0, horizontal: 5.0),
                    child: TextField(
                      controller: consumernamecontroller,
                      textInputAction: TextInputAction.done,
                      onEditingComplete: () => node.nextFocus(),
                      enableSuggestions: false,
                      autocorrect: false,
                      decoration: InputDecoration(
                        border: OutlineInputBorder(),
                        fillColor: Colors.white,
                        labelText: "Name",
                      ),
                    ),
                  ),
                  Container(
                    margin: EdgeInsets.all(25.0),
                    decoration: BoxDecoration(
                        borderRadius: BorderRadius.circular(5.0),
                        color: Colors.blue),
                    child: FlatButton(
                        onPressed: () {
                          data = {
                            'key': keycontroller.text,
                            'amount': amountcontroller.text,
                            'is_generated': 0,
                            'reference_number': referencenumbercontroller.text,
                            'callback': 'callbackflutter',
                            'customer_email_address':
                            customeremailcontroller.text,
                            'customer_phone_number':
                            customernumbercontroller.text,
                            'consumer_name': consumernamecontroller.text,
                          };

                          IbadCheckOut.initiateCheckOut(
                            Data: data,
                            context: context,
                            callback: (args) {
                              print("Callback data $args");
                              String abc = args.toString();
                              abc = abc.replaceAll( ',' , '\n' );
                              setState(() {
                                callbackdata = abc;
                              });
                            },
                          );
                        },
                        child: Text("Login")),
                  ),
                  Container(
                    margin:
                    EdgeInsets.symmetric(vertical: 5.0, horizontal: 10.0),
                    child: Text("$callbackdata", style: TextStyle(
                      fontSize: 18.0,
                      fontWeight: FontWeight.bold,
                    ),),
                  )
                ],
              ),
            )
          ],
        )
      ],
    );
  }
}
