library ibad;
import 'dart:async';
import 'dart:convert';
import 'dart:typed_data';
import 'package:flutter/material.dart';
import 'package:flutter_inappwebview/flutter_inappwebview.dart';

class IbadCheckOut {
  static Future initiateCheckOut({
    required Map<String,dynamic> Data,
    required BuildContext context,
    required Function callback,
  }) async {

    assert(Data != null, "No Data Recieved");


    return showDialog(
        context: context,
        builder: (context) {
          return  Scaffold(
              body: InAppWebView(
                initialUrlRequest: URLRequest(url: Uri.parse("https://portal-dev.riteidentity.com/fc.html")), //working one.
                initialOptions: InAppWebViewGroupOptions(
                    crossPlatform: InAppWebViewOptions(
                      useShouldOverrideUrlLoading: true,
                      javaScriptEnabled: true,
                      preferredContentMode: UserPreferredContentMode.DESKTOP,
                    ),
                    android: AndroidInAppWebViewOptions(
                      useHybridComposition: true,
                      textZoom: 110,
                    )
                ),
                onWebViewCreated: (InAppWebViewController controller) async {

                },
                onConsoleMessage: (controller, consoleMessage) {
                  print("On console message :  ${consoleMessage.message}");
                },

                onLoadStop: (controller, url) async {

                  String urlParamObj = json.encode(Data);
                  var postData = Uint8List.fromList(utf8.encode(urlParamObj));
                  String encoded = base64Encode(postData);

                  controller.evaluateJavascript(source: "const meta = document.createElement('meta'); meta.setAttribute('content', 'width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=0'); meta.setAttribute('name', 'viewport'); document.getElementsByTagName('head')[0].appendChild(meta);");

                  controller.evaluateJavascript(source: "initiateCheckout('$encoded')");

                  controller.addJavaScriptHandler(handlerName: 'message', callback: (args){
                    var postmessage = args.toString().substring(1, args.toString().length-1);
                    String decoded = utf8.decode(base64.decode(postmessage));
                    callback(decoded);
                    controller.goBack();
                    Navigator.pop(context, decoded);
                  });

                },

              ));
        });
  }
}

